import * as tslib_1 from "tslib";
import * as React from "react";
var Creator = (function (_super) {
    tslib_1.__extends(Creator, _super);
    function Creator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            broadcasting: false,
            error: false,
            message: "",
            txHash: "",
            mining: false,
            finished: false
        };
        _this.getRequest = function (hash) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var requestNetwork, response, e_1;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        requestNetwork = this.props.requestNetwork;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, requestNetwork.get({ hash: hash })];
                    case 2:
                        response = _a.sent();
                        if (!response.request) {
                            return [2, setTimeout(function () { return _this.getRequest(hash); }, 1000)];
                        }
                        return [3, 4];
                    case 3:
                        e_1 = _a.sent();
                        return [2, setTimeout(function () { return _this.getRequest(hash); }, 1000)];
                    case 4: return [2, this.setState({ mining: false, finished: true })];
                }
            });
        }); };
        _this.handlePublish = function (requestNetwork, payload) {
            _this.setState({ broadcasting: true });
            requestNetwork
                .create(payload.paymentAddress, payload.amount, payload.metadata)
                .on("broadcasted", function (_a) {
                var transaction = _a.transaction;
                _this.setState({
                    mining: true,
                    txHash: transaction.hash,
                    broadcasting: false
                });
                _this.getRequest(transaction.hash);
            })
                .then(function () {
                _this.setState({ finished: true });
            })
                .catch(function (err) {
                return _this.setState({
                    error: true,
                    broadcasting: false,
                    message: err.message.slice(1, -1).toUpperCase()
                });
            });
        };
        return _this;
    }
    Creator.prototype.render = function () {
        var _this = this;
        var _a = this.state, finished = _a.finished, broadcasting = _a.broadcasting, error = _a.error, txHash = _a.txHash, mining = _a.mining;
        var _b = this.props, component = _b.component, payload = _b.payload, requestNetwork = _b.requestNetwork, buttonText = _b.buttonText;
        var props = {
            ready: !(!requestNetwork.currentAccount || requestNetwork.networkMismatch),
            finished: finished,
            message: requestNetwork.currentAccount
                ? buttonText
                : "Please Login using MetaMask",
            error: error,
            mining: mining,
            broadcasting: broadcasting,
            publish: function () { return _this.handlePublish(requestNetwork, payload); },
            txHash: txHash
        };
        return React.createElement(component, props);
    };
    return Creator;
}(React.Component));
export { Creator };
//# sourceMappingURL=Creator.js.map